SystemOrganization addCategory: #Metaprogramacion!

TestCase subclass: #IncompleteConcreteSubclassesFinderTest
	instanceVariableNames: 'incompleteConcreteSubclassesFinder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!IncompleteConcreteSubclassesFinderTest methodsFor: 'running' stamp: 'JuanEdi 6/20/2013 14:49'!
setUp

	incompleteConcreteSubclassesFinder := IncompleteConcreteSubclassesFinder new.! !

!IncompleteConcreteSubclassesFinderTest methodsFor: 'test' stamp: 'JuanEdi 6/20/2013 17:09'!
testShouldListClassIfItShouldImplementTheMethodItself
	| missingImplementors |
	
	missingImplementors := incompleteConcreteSubclassesFinder subclassesOf: AbstractA missingImplementationOf: #anAbstractMethod.
	self assert: missingImplementors size = 1.
	self assert: (missingImplementors includes: AbstractA).! !

!IncompleteConcreteSubclassesFinderTest methodsFor: 'test' stamp: 'JuanEdi 6/20/2013 17:12'!
testShouldListDirectSubclassesNotImplementingAbstractMethod
	| missingImplementors |
	
	missingImplementors := incompleteConcreteSubclassesFinder subclassesOf: AbstractB missingImplementationOf: #anAbstractMethod.
	self assert: missingImplementors size = 1.
	self assert:  (missingImplementors includes: AbstractSubclassB).! !

!IncompleteConcreteSubclassesFinderTest methodsFor: 'test' stamp: 'JuanEdi 6/20/2013 17:10'!
testShouldListNoClasesOnImplementedMethod
	| missingImplementors |
	
	missingImplementors := incompleteConcreteSubclassesFinder subclassesOf: AbstractA missingImplementationOf: #aConcreteMethod.
	self assert: missingImplementors isEmpty.! !

!IncompleteConcreteSubclassesFinderTest methodsFor: 'test' stamp: 'JuanEdi 6/20/2013 17:10'!
testShouldNotListAbstractSubclassesNotImplementingMethod
	| missingImplementors |
	
	missingImplementors := incompleteConcreteSubclassesFinder subclassesOf: AbstractC missingImplementationOf: #anAbstractMethod.
	self assert: (missingImplementors includes: AbstractSubclassC) not.! !

!IncompleteConcreteSubclassesFinderTest methodsFor: 'test' stamp: 'JuanEdi 6/20/2013 17:11'!
testShouldNotListNestedSubclassesImplementingAbstractMethod
	| missingImplementors |
	
	missingImplementors := incompleteConcreteSubclassesFinder subclassesOf: AbstractC missingImplementationOf: #anAbstractMethod.
	self deny: (missingImplementors includes: NestedConcreteSubclassC).! !

!IncompleteConcreteSubclassesFinderTest methodsFor: 'test' stamp: 'JuanEdi 6/20/2013 17:13'!
testShouldNotListNestedSubclassesWithInheritedImplementation
	| missingImplementors |
	missingImplementors := incompleteConcreteSubclassesFinder subclassesOf: AbstractC missingImplementationOf: #anotherAbstractMethod.
	self assert: missingImplementors isEmpty.! !

!IncompleteConcreteSubclassesFinderTest methodsFor: 'test' stamp: 'JuanEdi 6/20/2013 17:14'!
testShouldOnlyListSubclassesMissingImplementationOfMessagesDefinedInTheHierarchy
	| missingImplementors |
	missingImplementors := incompleteConcreteSubclassesFinder subclassesOf: AbstractA missingImplementationOf: #anUnknownMethod.
	self assert: missingImplementors isEmpty.! !

Object subclass: #AbstractA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!AbstractA methodsFor: 'as yet unclassified' stamp: 'JuanEdi 6/19/2013 21:16'!
aConcreteMethod
! !

!AbstractA methodsFor: 'as yet unclassified' stamp: 'pb 6/19/2013 20:09'!
anAbstractMethod
	self subclassResponsibility ! !

Object subclass: #AbstractB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!AbstractB methodsFor: 'as yet unclassified' stamp: 'pb 6/19/2013 20:19'!
anAbstractMethod
	self subclassResponsibility ! !

AbstractB subclass: #AbstractSubclassB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

AbstractB subclass: #ConcreteSubclassB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ConcreteSubclassB methodsFor: 'as yet unclassified' stamp: 'pb 6/19/2013 20:37'!
anAbstractMethod! !

Object subclass: #AbstractC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!AbstractC methodsFor: 'as yet unclassified' stamp: 'JuanEdi 6/19/2013 21:07'!
anAbstractMethod
 	self subclassResponsibility.! !

!AbstractC methodsFor: 'as yet unclassified' stamp: 'JuanEdi 6/19/2013 21:19'!
anotherAbstractMethod
 	self subclassResponsibility.! !

AbstractC subclass: #AbstractSubclassC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!AbstractSubclassC methodsFor: 'as yet unclassified' stamp: 'JuanEdi 6/19/2013 21:19'!
anotherAbstractMethod
! !

AbstractSubclassC subclass: #NestedConcreteSubclassC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!NestedConcreteSubclassC methodsFor: 'as yet unclassified' stamp: 'JuanEdi 6/19/2013 21:12'!
anAbstractMethod
 	! !

AbstractC subclass: #ConcreteSubclassC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ConcreteSubclassC methodsFor: 'as yet unclassified' stamp: 'JuanEdi 6/19/2013 21:12'!
anAbstractMethod
 	! !

!ConcreteSubclassC methodsFor: 'as yet unclassified' stamp: 'JuanEdi 6/19/2013 21:19'!
anotherAbstractMethod! !

Object subclass: #IncompleteConcreteSubclassesFinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!IncompleteConcreteSubclassesFinder commentStamp: '<historical>' prior: 0!
An IncompleteConcreteSubclassesFinder is xxxxxxxxx.

Instance Variables
!

!IncompleteConcreteSubclassesFinder methodsFor: 'hierarchy-analisis' stamp: 'JuanEdi 6/20/2013 17:03'!
class: aClass definesBehaviourFor: aMessageSelector
	"Nos dice si instancias de aClass saben responder al mensaje con un mtodo no abstracto.
	Esta ltima es la diferencia con 'aClass canUnderstand: aMessageSelector'"
	
	aClass classAndMethodFor: aMessageSelector
			do: [ :implementingClass :compiledMethod | ^ compiledMethod isAbstract not ]
			ifAbsent:  [ ^false ].! !

!IncompleteConcreteSubclassesFinder methodsFor: 'hierarchy-analisis' stamp: 'JuanEdi 6/20/2013 15:24'!
concreteClassesInHierarchyOf: aClass
	^ aClass withAllSubclasses select: [ :aSubclass | self isConcrete: aSubclass ].! !

!IncompleteConcreteSubclassesFinder methodsFor: 'hierarchy-analisis' stamp: 'JuanEdi 6/20/2013 17:07'!
isConcrete: aClass
	"Segn nuestros principios de diseo, el hecho de que una clase est al fondo de una jerarqua implica que debera ser concreta.
	Si esta clase no llegase a definir el comportamiento de un mtodo abstracto, consideramos esto seal de que se omiti hacerlo, pero
	no por eso dejamos de considerarla concreta."
	^ aClass subclasses isEmpty.! !

!IncompleteConcreteSubclassesFinder methodsFor: 'hierarchy-analisis' stamp: 'JuanEdi 6/20/2013 17:05'!
subclassesOf: aClass missingImplementationOf: aMessageSelector 
	"Aqu suponemos que desde aClass analizamos la jerarqua polimrfica. Nos interesa analizar todas las subclases
	que estn al fondo de la misma. Estas son las clases que deberan ser efectivamente concretas, y por ende quereremos
	detectar cundo no saben responder a algn mensaje definido en la jerarqua."
	
	(aClass canUnderstand: aMessageSelector)
		ifTrue: [
			"El mensaje est presente en la jerarqua que nace en aClass. Todas las subclases concretas deben saber responder al mismo."
			^ (self concreteClassesInHierarchyOf: aClass) reject: [ :aSubclass | self class: aSubclass definesBehaviourFor: aMessageSelector ]. 
		]
	 	ifFalse: [
			"El mensaje no forma parte del contrato de la jerarqua polimrfica. Ergo, ninguna subclase tiene por qu implementar este mensaje."
			^ Set new.
		].! !
